REM git@github.com:frankosterfeld/qtkeychain.git

set P=qtkeychain-qt5
set V=0.7
set B=1

if "%OSGEO4W_REP%"=="" (
	echo no repository
	exit 1
)

if "%ARCH%"=="x86" (
	set OSGEO4W_ROOT=C:\OSGeo4W
	set VCARCH=x86
	set CMAKE_GEN=Visual Studio 14 2015
) else if "%ARCH%"=="x86_64" (
	set OSGEO4W_ROOT=C:\OSGeo4W64
	set VCARCH=amd64
	set CMAKE_GEN=Visual Studio 14 2015 Win64
) else (
	echo invalid arch
	exit
)

set R=%OSGEO4W_REP%\%ARCH%\release\qt5\%P%
for %%i in (devel libs) do (
	if not exist %R%\%P%-%%i mkdir %R%\%P%-%%i
	copy %%i.hint %R%\%P%-%%i\setup.hint
	copy ..\COPYING %R%\%P%-%%i\%P%-%%i-%V%-%B%.txt
)

call "%OSGEO4W_ROOT%\bin\o4w_env.bat"
call "%OSGEO4W_ROOT%\bin\qt5_env.bat"
call "c:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" %VCARCH%
path %PATH%;c:\cygwin\bin;C:\Program Files\CMake\bin
echo on

set BUILDDIR=%CD%\build-%ARCH%
if not exist %BUILDDIR% mkdir %BUILDDIR%
set INSTDIR=%OSGEO4W_ROOT%
if not exist %INSTDIR% mkdir %INSTDIR%

cd %BUILDDIR%

set LIB=%LIB%;%OSGEO4W_ROOT%\lib
set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\include

set BUILDCONF=RelWithDebInfo

cmake -G "%CMAKE_GEN%" ^
	-DCMAKE_CONFIGURATION_TYPES=%BUILDCONF% ^
	-DCMAKE_INSTALL_BINDIR=%INSTDIR%/apps/Qt5/bin ^
	-DCMAKE_INSTALL_LIBDIR=%INSTDIR%/apps/Qt5/lib ^
	-DCMAKE_INSTALL_INCLUDEDIR=%INSTDIR%/apps/Qt5/include ^
	-DPKGCONFIG_INSTALL_PREFIX=%INSTDIR%/apps/Qt5/lib/pkgconfig ^
        ../..
if errorlevel 1 goto error

for %%i in (ZERO_CHECK ALL_BUILD INSTALL) do (
	echo %%i: %DATE% %TIME%
	cmake --build . --target %%i --config %BUILDCONF%
	if errorlevel 1 (echo %%i error & goto error)
)

cd ..

tar -C %OSGEO4W_ROOT% -cvjf %R:d:=/d%/%P%-devel/%P%-devel-%V%-%B%.tar.bz2 ^
	apps/Qt5/include/qt5keychain ^
	apps/Qt5/lib/qt5keychain.lib ^
	apps/Qt5/lib/cmake/Qt5Keychain
if errorlevel 1 goto error

tar -C %OSGEO4W_ROOT% -cvjf %R:d:=/d%/%P%-libs/%P%-libs-%V%-%B%.tar.bz2 ^
	apps/Qt5/translations/qtkeychain_de.qm ^
	apps/Qt5/translations/qtkeychain_ro.qm ^
	apps/Qt5/bin/qt5keychain.dll
	
if errorlevel 1 goto error

tar -C .. -cvjf %R:d:=/d%/%P%-libs/%P%-libs-%V%-%B%-src.tar.bz2 ^
	osgeo4w/package.cmd ^
	osgeo4w/libs.hint ^
	osgeo4w/devel.hint
if errorlevel 1 goto error

exit

:error
